#  Licensed Materials - Property of IBM
#  5724-M24
#  Copyright IBM Corporation 2007, 2009. All Rights Reserved.
#  US Government Users Restricted Rights - Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.
#

import java

if ((len(sys.argv) != 1)):
        print "This script requires 1 parameter: profilePath"
        print "e.g.: <scriptname>.py /opt/WebSphere/Monitor/profiles/MonSrv01"
	raise ValueError	

profilePath = sys.argv[0]
print "profilePath="+profilePath
execfile(profilePath+'/config.wbm/MonitorProfileVals.py')

location = washome+"/installableApps.wbm"
ear = aamEarName
app = aamAppname
cell     = cellName
node     = nodeName
server   = serverName

print "location: "+location+" app: "+app+" cell: "+cell+" node: "+node+"server: "+server

execfile(moncommonPath+'/MonitorServerUtil.py')
UtilWsadminHolder.AdminConfig = AdminConfig
UtilWsadminHolder.AdminTask = AdminTask

scope = Scope(clusterName, cell, node, server)
print "scope="+str(scope)

rc = 0
#create a queue destination on Monitor Bus
busName = "MONITOR." + cell + ".Bus"

#create SIB JMS
print "create SIB JMS resource"
cellConfigId = scope.getConfigId(Scope.CELL_SCOPE)

#Queue Connection Factory
optList = "-name \""+aamQConnFactoryName+"\" -jndiName "+aamQConnFactoryJndi+" -busName "+busName+" -type Queue -containerAuthAlias "+busAliasName+" -authDataAlias "+busAliasName
print "creating queue connection factory optList="+optList
try:
    AdminTask.createSIBJMSConnectionFactory(cellConfigId,optList)
    AdminConfig.save()
except:
    print "warning: failed to createSIBJMSConnectionFactory. The queue connection factory may already be created."	
    rc = -1
print "done creating queue connection factory"

#Queue
optList = "-name \""+aamQName+"\" -jndiName "+aamQJndi+" -busName "+busName+" -queueName "+aamQDestName
print "creating queue optList="+optList
try:
    AdminTask.createSIBJMSQueue(cellConfigId,optList)
    AdminConfig.save()
except:
    print "warning: failed to createSIBJMSQueue. The queued may already be created."
    rc = -1
print "done creating queue"

#ActivationSpec
optList = "-name \""+aamActivationSpecName+"\" -jndiName "+aamActivationSpecJndi+" -busName "+busName+" -destinationJndiName "+aamQJndi+" -authenticationAlias "+busAliasName+" -maxBatchSize 10"+" -maxConcurrency 10"
print "creating activation specification optList="+optList
try:
    AdminTask.createSIBJMSActivationSpec(cellConfigId,optList)
    AdminConfig.save()
except:
    print "warning: failed to createSIBJMSActivationSpec. The activation specification may already be created."	
    rc = -1
print "done creating activation specification"

#Create Event Group
print "Creating EventProfile"  
try:
    # Get EventProfile Group id
    optList = "/EventInfrastructureProvider:EventInfrastructureProvider/EventGroupProfileList:Event groups list/"
    print "optList="+ str(optList)
    egpl = AdminConfig.getid(optList)
    print "egpl="+str(egpl)

    if(egpl != None and egpl != ""):
        # Create the EventGroupProfile
        eventSelectorString = "CommonBaseEvent[extendedDataElements/@name = 'BusinessSituationName']"
        optList = [["eventGroupName",aamEventGroupName], ["eventSelectorString",aamEventSelectorString]]
        print "optList="+str(optList)
        epg = AdminConfig.create("EventGroupProfile",egpl,optList)
        print "epg="+str(epg)
        
        # Create the DistributionQueue
        optList = [["queueConnectionFactoryJNDIName",aamQConnFactoryJndi], ["queueJNDIName",aamQJndi]]
        print "optList=" + str(optList)
        dq = AdminConfig.create("DistributionQueue",epg,optList)
        print "dq="+str(dq)
        AdminConfig.save()
    else:
        print aamEventGroupName +"is not created because CEI is not enabled."
except:
    print "warning: failed to create EventProfile."
    rc = -1
print "done Creating EventProfile"


# Register DEF
print "Creating DEF config"  
try:
	defProducerConfigOptions = [];
	defProducerConfigId = AdminConfig.create("DefProducerConfig", cellConfigId, defProducerConfigOptions);
	
	defProducerConfigOptions = [["producerId", "ProducersForActionManager"]];
	defProducerId = AdminConfig.create("DefProducer", defProducerConfigId, defProducerConfigOptions);
	
	defProducerFilter1Options =[["filterId", "ProducersForActionManager_1"], ["appName", "*"], ["version", "*"], ["componentType", "*"], ["componentName", "*"], ["elementType", "*"], ["elementName", "*"], ["nature", "MonitorErrorOutboundEvent"]];
	defProducerFilter1Id = AdminConfig.create("DefFilter", defProducerId, defProducerFilter1Options);
	
	defProducerFilter2Options =[["filterId", "ProducersForActionManager_2"], ["appName", "*"], ["version", "*"], ["componentType", "*"], ["componentName", "*"], ["elementType", "*"], ["elementName", "*"], ["nature", "MonitorBusinessSituation"]];
	defProducerFilter2Id = AdminConfig.create("DefFilter", defProducerId, defProducerFilter2Options);
	
	defProducerFilter3Options =[["filterId", "ProducersForActionManager_3"], ["appName", "DynamicAlert"], ["version", "*"], ["componentType", "*"], ["componentName", "*"], ["elementType", "*"], ["elementName", "*"], ["nature", "*"]];
	defProducerFilter3Id = AdminConfig.create("DefFilter", defProducerId, defProducerFilter3Options);
	
	defProducerFilter4Options =[["filterId", "ProducersForActionManager_4"], ["appName", "*"], ["version", "*"], ["componentType", "*"], ["componentName", "*"], ["elementType", "*"], ["elementName", "*"], ["nature", "MonitorOutboundEvent"]];
	defProducerFilter4Id = AdminConfig.create("DefFilter", defProducerId, defProducerFilter4Options);
	
	
	defListenerConfigOptions = [];
	defListenerConfigId = AdminConfig.create("DefListenerConfig", cellConfigId, defListenerConfigOptions);
	
	defListenerConfigOptions = [["listenerId", "ListenerForActionManager"], ["listenerFactoryId", "com.ibm.wbimonitor.actionmgr.defext.ActionManagerDefEventListenerFactory"]];
	defListenerId = AdminConfig.create("DefListener", defListenerConfigId, defListenerConfigOptions);
	
	defListenerProperties1Options = [["name", "Q_JNDI"], ["value", aamQJndi]];
	defListenerProperties1Id = AdminConfig.create("DefProperty", defListenerId, defListenerProperties1Options);
	
	defListenerProperties2Options = [["name", "QCF_JNDI"], ["value", aamQConnFactoryJndi]];
	defListenerProperties2Id = AdminConfig.create("DefProperty", defListenerId, defListenerProperties2Options);
	
	defListenerFilter1Options =[["filterId", "ListenerForActionManager_1"], ["appName", "*"], ["version", "*"], ["componentType", "*"], ["componentName", "*"], ["elementType", "*"], ["elementName", "*"], ["nature", "MonitorErrorOutboundEvent"]];
	defListenerFilter1Id = AdminConfig.create("DefFilter", defListenerId, defListenerFilter1Options);
	
	defListenerFilter2Options =[["filterId", "ListenerForActionManager_2"], ["appName", "*"], ["version", "*"], ["componentType", "*"], ["componentName", "*"], ["elementType", "*"], ["elementName", "*"], ["nature", "MonitorBusinessSituation"]];
	defListenerFilter2Id = AdminConfig.create("DefFilter", defListenerId, defListenerFilter2Options);
	
	defListenerFilter3Options =[["filterId", "ListenerForActionManager_3"], ["appName", "DynamicAlert"], ["version", "*"], ["componentType", "*"], ["componentName", "*"], ["elementType", "*"], ["elementName", "*"], ["nature", "*"]];
	defListenerFilter3Id = AdminConfig.create("DefFilter", defListenerId, defListenerFilter3Options);

	defListenerFilter4Options =[["filterId", "ListenerForActionManager_4"], ["appName", "*"], ["version", "*"], ["componentType", "*"], ["componentName", "*"], ["elementType", "*"], ["elementName", "*"], ["nature", "MonitorOutboundEvent"]];
	defListenerFilter4Id = AdminConfig.create("DefFilter", defListenerId, defListenerFilter4Options);
	
	
	AdminConfig.save();
except:
    print "warning: failed to create DEF config."
    rc = -1
print "done Creating DEF config"


if (ndType != "dmgr"):
    #install EAR
    execfile(moncommonPath+'/installEar.py')
    rc2 = installEar(location, ear, app, node, server)
    if(rc2 == -1):
        rc = -1
            
if(rc == -1):
    raise ValueError("Install and/or configure ActionServices failed")
