@echo off
@REM **************************************************************************
@REM Licensed Material - Property of IBM
@REM 5724-M24
@REM Copyright IBM Corporation 2014. All Rights Reserved.
@REM US Government Users Restricted Rights- Use, duplication or disclosure
@REM restricted by GSA ADP Schedule Contract with IBM Corp.
@REM **************************************************************************
@REM 
@REM **************************************************************************
setlocal

@REM ##################################################################################################################################
@REM #                                                                                                                                #
@REM # Read command line options                                                                                                      #
@REM #Usage:                                                                                                                          #
@REM #MonitorModelMigration -profileName <database type> -modelDir <model_location> -user <admin_user> -password <admin_password>     #
@REM # -clusterName <clusterName> | -nodeName <node_name> -serverName <server_name>                                                   #
@REM #where:                                                                                                                          #
@REM #-profileName:                                                                                                                   #
@REM #     Dmgr profile name of source cell                                                                                           #
@REM #-modelDir:                                                                                                                      #
@REM #     The directory where monitor model application would be read                                                                #
@REM #-user:                                                                                                                          #
@REM #      User name used to connect to Dmgr process                                                                                 #
@REM #-password:                                                                                                                      #
@REM #     Password used to connect to Dmgr process                                                                                   #
@REM #-clusterName:                                                                                                                   #
@REM #     The value is cluster name where you want to deploy the monitor models                                                      #
@REM #-nodeName:                                                                                                                      #
@REM #     The value is node name where you want to deploy the monitor models                                                         #
@REM #-serverName:                                                                                                                    #
@REM #     The value is server name where you want to deploy the monitor models                                                       #
@REM # Usage Example:                                                                                                                 #
@REM # MonitorModelMigration.bat -profileName Dmgr01 -modelDir C:\monitorModels -user admin -password admin -clusterName monAppTarget #
@REM #                              																								  #
@REM ##################################################################################################################################

IF "%1" == "" GOTO help
IF "%1" == "-?" GOTO help
IF "%1" == "-help" GOTO help

:Loop
IF "%1" == "" GOTO ahead
IF "%1" == "-profileName" (
  set profileName=%2
  GOTO Forward
)
IF "%1" == "-modelDir" (
  set modelDir=%2
  GOTO Forward
)
IF "%1" == "-user" (
  set user=%2
  GOTO Forward
)
IF "%1" == "-password" (
  set password=%2
  GOTO Forward
)
IF "%1" == "-clusterName" (
  set clusterName=%2
  GOTO Forward
)
IF "%1" == "-nodeName" (
  set nodeName=%2
  GOTO Forward
)
IF "%1" == "-serverName" (
  set serverName=%2
  GOTO Forward
)

:help
ECHO.
ECHO Usage:
ECHO     MonitorModelMigration -profileName ^<database type^> -modelDir ^<model_location^> -user ^<admin_user^> -password ^<admin_password^> ^[-clusterName ^<clusterName^> ^| -nodeName ^<node_name^> -serverName ^<server_name^>^]
ECHO.
ECHO where:
ECHO     -?, -help      This help message
ECHO     -profileName:  Dmgr profile name of source cell 	
ECHO     -modelDir:     The directory where monitor model application would be read
ECHO     -user:         User name used to connect to Dmgr process
ECHO     -password:     Password used to connect to Dmgr process
ECHO     -clusterName:  The value is cluster name where you want to deploy the monitor models (Required if the target environment is a network deployment environment)
ECHO     -nodeName:     The value is node name where you want to deploy the monitor models (Required if the target environment is a stand-alone environment)
ECHO     -serverName:   The value is server name where you want to deploy the monitor models (Required if the target environment is a stand-alone environment)
ECHO.
ECHO Usage Example:
ECHO     MonitorModelMigration.bat -profileName Dmgr01 -modelDir C:\monitorModels -user admin -password admin -clusterName monAppTarget
ECHO.
ECHO     MonitorModelMigration.bat -profileName Dmgr01 -modelDir C:\monitorModels -user admin -password admin -nodeName monNode01 -serverName server1
GOTO done

:Forward
shift /1
shift /1
GOTO Loop
:ahead

set CUR_DIR=%cd%
cd /d "%~dp0\..\..\.."
set WAS_HOME=%cd%
cd /d "%CUR_DIR%"

set MY_CLASSPATH=%WAS_HOME%\plugins\com.ibm.wbimonitor.lifecycle.spi.jar;%WAS_HOME%\plugins\com.ibm.wbimonitor.persistence.jar;%WAS_HOME%\plugins\com.ibm.wbimonitor.util.jar;%WAS_HOME%\plugins\com.ibm.wbimonitor.monresources_10.0.0.v201401011700.jar;%WAS_HOME%\plugins\com.ibm.ws.wccm.jar;%WAS_HOME%\plugins\com.ibm.ws.admin.services.jar;%WAS_HOME%\plugins\com.ibm.bpm.config.jar

"%WAS_HOME%"\bin\wsadmin.bat -conntype SOAP -profileName %profileName% -username %user% -password %password% -javaoption -Xmx2048m -wsadmin_classpath "%MY_CLASSPATH%" -lang jython -f "%WAS_HOME%"\scripts.wbm\migration\ModelMigration\MonitorModelMigration.py -migrate %modelDir% %clusterName% %node% %server% 

cd /d "%CUR_DIR%"

:done
endlocal
@echo off