@rem  Licensed Materials - Property of IBM
@rem  5724-M24
@rem  Copyright IBM Corporation 2007, 2012. All Rights Reserved.
@rem  US Government Users Restricted Rights- Use, duplication or disclosure
@rem  restricted by GSA ADP Schedule Contract with IBM Corp.
@ECHO off

setlocal EnableDelayedExpansion

GOTO Variables
@REM #######################################################
@REM #                                                     #
@REM # Variables                                           #
@REM #                                                     #
@REM #######################################################
:Variables

@REM #######################################################
@REM #                                                     #
@REM # Initialize Variables                                #
@REM #                                                     #
@REM #######################################################
SET RC=0
SET THIS_CLASSPATH=
set jarExists=false
set JSON4JExists=false
set lifecycleExists=false
set lifecycle_spiExists=false
set repositoryExists=false
set THINCLIENT_JAR_FILE=

@REM #######################################################
@REM #                                                     #
@REM # Set WAS_HOME                                        #
@REM #                                                     #
@REM #######################################################

set WAS_HOME=
set curDir=%~dp0
set WAS_HOME_PREP="%~dp0.."
for %%i in (%WAS_HOME_PREP%) do (set WAS_HOME=%%~dpi)

set dmgrName=""
set userId=""
set password=""
set propertiesFile=%WAS_HOME%\scripts.wbm\monConfig\monConfig.properties
set monConfigScript=%WAS_HOME%scripts.wbm\MonConfig\MonConfig.jy

@REM #######################################################
@REM #                                                     #
@REM # Read command line options                           #
@REM #                                                     #
@REM #######################################################
:Loop
IF [%1]==[] GOTO Continue
if [%1]==[-c] set propertiesFile=%2&shift&shift&goto Loop
if [%1]==[-d] set dmgrName=%2&shift&shift&goto Loop
if [%1]==[-p] set password=%2&shift&shift&goto Loop
if [%1]==[-u] set userId=%2&shift&shift&goto Loop

:Continue
IF EXIST %propertiesFile% SET propertiesFileExists=true
IF "%propertiesFileExists%"=="" (
  SET RC=-1
  ECHO EXIT:     Properties file %propertiesFile% does not exist.
  GOTO INTERIM_END
)

IF %propertiesFile%. == "". (
  SET RC=-1
  ECHO.
  ECHO.
  ECHO EXIT:     A value for the -c parameter is required. 
  GOTO USAGE
)

IF %dmgrName%. == "". (
  SET RC=-1
  ECHO.
  ECHO.
  ECHO EXIT:     A value for the -d parameter is required. 
  GOTO USAGE
)

IF %password%. == "". (
  SET RC=-1
  ECHO.
  ECHO.
  ECHO EXIT:     A value for the -p parameter is required. 
  GOTO USAGE
)

IF %userId%. == "". (
  SET RC=-1
  ECHO.
  ECHO.
  ECHO EXIT:     A value for the -u parameter is required. 
  GOTO USAGE
)

set jarExists=false
IF EXIST %WAS_HOME%lib\wbminstall_util.jar SET jarExists=true
IF "%jarExists%"=="false" (
  SET RC=-1
  ECHO EXIT:     jar file %WAS_HOME%lib\wbminstall_util.jar does not exist.
  GOTO INTERIM_END
) ELSE (
	SET THIS_CLASSPATH="%WAS_HOME%lib\wbminstall_util.jar"
)

set jarExists=false
IF EXIST %WAS_HOME%lib\wbminstall_log.jar SET jarExists=true
IF "%jarExists%"=="false" (
  SET RC=-1
  ECHO EXIT:     jar file "%WAS_HOME%"lib\wbminstall_log.jar does not exist.
  GOTO INTERIM_END
) ELSE (
	SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%lib\wbminstall_log.jar"
)

set jarExists=false
IF EXIST %WAS_HOME%scripts.wbm\MonConfig\lib\JSON4J.jar SET jarExists=true
IF "%jarExists%"=="false" (
  SET RC=-1
  ECHO EXIT:     jar file %WAS_HOME%scripts.wbm\MonConfig\lib\JSON4J.jar does not exist.
  GOTO INTERIM_END
) ELSE (
	SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%scripts.wbm\MonConfig\lib\JSON4J.jar"
)

set jarExists=false
IF EXIST %WAS_HOME%plugins\com.ibm.wbimonitor.lifecycle.jar SET jarExists=true
IF "%jarExists%"=="false" (
  SET RC=-1
  ECHO EXIT:     jar file %WAS_HOME%plugins\com.ibm.wbimonitor.lifecycle.jar does not exist.
  GOTO INTERIM_END
) ELSE (
	SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%plugins\com.ibm.wbimonitor.lifecycle.jar"
)

set jarExists=false
IF EXIST %WAS_HOME%plugins\com.ibm.wbimonitor.lifecycle.spi.jar SET jarExists=true
IF "%jarExists%"=="false" (
  SET RC=-1
  ECHO EXIT:     jar file %WAS_HOME%plugins\com.ibm.wbimonitor.lifecycle.spi.jar does not exist.
  GOTO INTERIM_END
) ELSE (
	SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%plugins\com.ibm.wbimonitor.lifecycle.spi.jar"
)

set jarExists=false
IF EXIST %WAS_HOME%plugins\com.ibm.wbimonitor.repository.jar SET jarExists=true
IF "%jarExists%"=="false" (
  SET RC=-1
  ECHO EXIT:     jar file %WAS_HOME%plugins\com.ibm.wbimonitor.repository.jar does not exist.
  GOTO INTERIM_END
) ELSE (
	SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%plugins\com.ibm.wbimonitor.repository.jar"
)

set jarExists=false
IF EXIST %WAS_HOME%plugins\com.ibm.bpm.config.jar SET jarExists=true
IF "%jarExists%"=="false" (
  SET RC=-1
  ECHO EXIT:     jar file %WAS_HOME%plugins\com.ibm.bpm.config.jar does not exist.
  GOTO INTERIM_END
) ELSE (
	SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%plugins\com.ibm.bpm.config.jar"
)

REM FOR /F "delims=" %%i IN ('DIR /a-d /b /s "%WAS_HOME%\runtimes" 2^>NUL ^| findstr "com.ibm.ws.ejb.thinclient_" 2^>NUL') DO SET THINCLIENT_JAR_FILE=%%i
FOR /F "delims=" %%i IN ('DIR /a-d /b /s "%WAS_HOME%\runtimes" 2^>NUL ^| findstr "com.ibm.ws.ejb.thinclient_" 2^>NUL') DO CALL :findThinClientJarFile %%i
IF "%THINCLIENT_JAR_FILE%"=="" (
  SET RC=-1
  ECHO.
  ECHO.
  ECHO EXIT:     Jar file com.ibm.ws.ejb.thinclient_*.jar does not exist under the 
  ECHO           %WAS_HOME%\runtimes directory.
  GOTO INTERIM_END
) ELSE (
	SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%THINCLIENT_JAR_FILE%"
)
set THIS_CLASSPATH=%THIS_CLASSPATH:\=/%

ECHO call "%WAS_HOME%bin\wsadmin.bat" -profileName %dmgrName% -conntype SOAP -username %userId% -password %password% -lang jython -wsadmin_classpath %THIS_CLASSPATH% -f %monConfigScript% %propertiesFile%
call %WAS_HOME%bin\wsadmin.bat -profileName %dmgrName% -conntype SOAP -username %userId% -password %password% -lang jython -wsadmin_classpath %THIS_CLASSPATH% -f %monConfigScript% %propertiesFile%

:findThinClientJarFile
SET str1="%1"
IF NOT x%str1:com.ibm.ws.ejb.thinclient_=%==x%str1% SET THINCLIENT_JAR_FILE=%1
GOTO INTERIM_END

:interim_end
IF "%RC%"=="0" (
  ECHO. >NUL
) ELSE (
  ECHO FAIL: monConfig did not complete successfully. 
  ECHO       See the previous message^(s^) for the cause.
  ECHO.
  ECHO.
)

EXIT /B %RC%
ENDLOCAL

@REM #######################################################
@REM #                                                     #
@REM # monConfig Usage                                           #
@REM #                                                     #
@REM #######################################################
:USAGE
  ECHO.
  ECHO  monConfig.bat -d ^<DMgr profile name^> -u ^<user name^> -p ^<Dmgr password^> -c ^<properties file^> 
  ECHO.
  ECHO  where:  
  ECHO.
  ECHO   -d ^<Deployment Manager profile name^>: REQUIRED. WAS Deployment Manager profile name.
  ECHO.
  ECHO   -u ^<Deployment Manager user name^>: REQUIRED. WAS Deployment Manager user id.
  ECHO.
  ECHO   -p ^<Deployment Manager password^>: REQUIRED. WAS Deployment Manager user password
  ECHO.
  ECHO   -c ^<Properties file^>: REQUIRED. The fully qualified path of the monConfig properties file including the properties filename.
  ECHO.
  GOTO END

:end
IF "%RC%"=="0" (
  ECHO.
  ECHO.
  ECHO SUCCESS: monConfig completed.
  ECHO.
) ELSE (
  ECHO.
  ECHO.
  ECHO FAIL: monConfig did not complete successfully. 
  ECHO.
)
EXIT /B %RC%
ENDLOCAL

